---
title: RTCInboundRtpStreamStats.qpSum
slug: Web/API/RTCInboundRtpStreamStats/qpSum
tags:
  - API
  - Property
  - QP
  - Quantization
  - RTCInboundRtpStreamStats
  - Reference
  - Statistics
  - Stats
  - Video
  - WebRTC
  - WebRTC API
  - qpSum
  - stream
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">The <strong><code>qpSum</code></strong> property of the {{domxref("RTCInboundRtpStreamStats")}} dictionary is a value generated by adding the <strong>Quantization Parameter</strong> (<strong>QP</strong>) values for every frame sent or received to date on the video track corresponding to this <code>RTCInboundRtpStreamStats</code> object.</span> In general, the higher this number is, the more heavily compressed the video data is.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var qpSum = <em>rtcInboundRtpStreamStats</em>.qpSum;</pre>

<h3 id="Value">Value</h3>

<p>An unsigned 64-bit integer value which indicates the sum of the quantization parameter (QP) value for every frame sent or received so far on the track described by the {{domxref("RTCInboundRtpStreamStats")}} object. Since the value of QP is typically larger to indicate higher compression factors, the larger this sum is, the more heavily compressed the stream generally has been.</p>

<div class="note">
<p><strong>Note:</strong> This value is only available for video media.</p>
</div>

<h2 id="Usage_notes">Usage notes</h2>

<p>{{interwiki("wikipedia", "Quantization")}} is the process of applying lossy compression to a range of values, resulting in a single <strong>quantum value</strong>. This value takes the place of the range of values, thereby reducing the number of different values that appear in the overall data set, making the data more compressible. The quantization process and the amount of compression can be controlled using one or more parameters.</p>

<p>It's important to keep in mind that the value of QP can change periodically—even every frame—so it's difficult to know for certain how substantial the compression is. The best you can do is make an estimate. You can, for example, use the value of {{domxref("RTCReceivedRtpStreamStats.framesDecoded")}} if receiving the media or {{domxref("RTCSentRtpStreamStats.framesEncoded")}} if sending it to get the number of frames handled so far, and compute an average from there. See {{anch("Calculating average quantization")}} below for a function that does this.</p>

<p>Also, the exact meaning of the QP value depends on the {{Glossary("codec")}} being used. For example, for the VP8 codec, the QP value can be anywhere from 1 to 127 and is found in the frame header element <code>"y_ac_qi"</code>, whose value is defined in {{RFC(6386, "19.2")}}. H.264 uses a QP which ranges from 0 to 51; in this case, it's an index used to derive a scaling matrix used during the quantization process. Additionally, QP is not likely to be the only parameter the codec uses to adjust the compression. See the individual codec specifications for details.</p>

<h2 id="Example">Example</h2>

<h3 id="Calculating_average_quantization">Calculating average quantization</h3>

<p>The <code>calculateAverageQP()</code> function shown below computes the average QP for the given {{domxref("RTCStats")}} object that contains RTP stream statistics, returning 0 if the object doesn't describe an RTP stream.</p>

<pre class="brush: js">function calculateAverageQP(stats) {
  let frameCount = 0;

  switch(stats.type) {
    case "inbound-rtp":
    case "remote-inbound-rtp":
      frameCount = stats.framesDecoded;
      break;
    case "outbound-rtp":
    case "remote-outbound-rtp":
      frameCount = stats.framesEncoded;
      break;
    default:
      return 0;
  }

  return status.qpSum / frameCount;
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebRTC Statistics Identifiers', '#dom-rtcinboundrtpstreamstats-qpsum', 'RTCInboundRtpStreamStats.qpSum')}}</td>
   <td>{{Spec2('WebRTC Statistics Identifiers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCInboundRtpStreamStats.qpSum")}}</p>
